#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin>>t;
    vector<int> sum1;
    while(t>0)
    {
        int n;
        cin>>n;
        vector<int> a(n);
        vector<int> b(n);
        vector<int> c(n);

        for(int i=0; i<n; i++)
        {
            cin >> a[i] >> b[i] >> c[i];
        }

        int** gr = new int*[n*2];
        for(int i=0; i<n*2; i++)
        {
            gr[i] = new int[n*2];
            for(int j=1; j<n*2; j++)
            {
                gr[i][j]=0;
            }
        }
        for(int i=0; i<n; i++)
        {
            gr[a[i]-1][b[i]-1] = c[i];
            gr[b[i]-1][a[i]-1] = c[i];
        }
        int sum=0;
        int*s1 = new int[n*2];
        for(int i=0; i<n*2; i++)
        {
            partial_sum(&gr[i][0], &gr[i][2*n], s1);
            if(s1[n*2-1]>sum)
            {
                sum=s1[n*2-1];
            }
            if(gr[i][0]>0)
            {
                for(int j=1; j<n*2; j++)
                {
                    if(gr[i][j]>0 && gr[j][0]>0)
                    {
                        if(gr[i][j]+gr[i][0]+gr[j][0]>sum)
                        {
                            sum = gr[i][j]+gr[i][0]+gr[j][0];
                        }
                    }
                }
            }
        }
    
        cout << sum << endl;
        t--;
    }

}

